function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import Backbone from "backbone";

import { CONTEXT_KEY } from "../const";
import getDisplayName from "../utils/getDisplayName";
import shallowEqual from "../utils/shallowEqual";
import StoreWatcher from "../StoreWatcher";
import createMapToProps from "./createMapToProps";

export default (function (mapModelToProps, mapTriggerToProps, mergeProps) {
  return function (WrappedComponent) {
    var _Connectted$contextTy;

    var Connectted = function (_Component) {
      _inherits(Connectted, _Component);

      function Connectted(props, context) {
        _classCallCheck(this, Connectted);

        var _this = _possibleConstructorReturn(this, _Component.call(this, props, context));

        _this.storeWatcher = new StoreWatcher(context[CONTEXT_KEY]);
        _this.mapToProps = createMapToProps(_this.storeWatcher.wrappedStore, props, mapModelToProps, mapTriggerToProps, mergeProps);

        _this.state = {
          mergedProps: _this.mapToProps.getMergedProps()
        };

        _this.storeWatcher.on("change", function () {
          _this.mapToProps.storeUpdated();
          _this.setState({
            mergedProps: _this.mapToProps.getMergedProps()
          });
        });
        return _this;
      }

      Connectted.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
        if (shallowEqual(this.props, nextProps)) {
          return;
        }
        this.mapToProps.updateProps(nextProps);
        this.mapToProps.getMergedProps();
        this.setState({
          mergedProps: this.mapToProps.getMergedProps()
        });
      };

      Connectted.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
        return this.state.mergedProps !== nextState.mergedProps;
      };

      Connectted.prototype.componentWillUnmount = function componentWillUnmount() {
        this.storeWatcher.destory();
      };

      Connectted.prototype.render = function render() {
        return React.createElement(WrappedComponent, this.state.mergedProps);
      };

      return Connectted;
    }(Component);

    Connectted.displayName = "BackboneConnect(" + getDisplayName(WrappedComponent) + ")";
    Connectted.contextTypes = (_Connectted$contextTy = {}, _Connectted$contextTy[CONTEXT_KEY] = PropTypes.object, _Connectted$contextTy);
    Connectted.WrappedComponent = WrappedComponent;

    return Connectted;
  };
});