export var createSelector = function createSelector() {
  for (var _len = arguments.length, selectors = Array(_len), _key = 0; _key < _len; _key++) {
    selectors[_key] = arguments[_key];
  }

  if (!selectors || selectors.length < 2) {
    throw new Error("createSelector must have at least one selector and one resultFunc");
  }
  var resultFunc = selectors.pop();
  return function (store) {
    for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
      args[_key2 - 1] = arguments[_key2];
    }

    var values = selectors.map(function (selector) {
      return selector.apply(undefined, [store].concat(args));
    });
    return resultFunc.apply(undefined, values.concat(args));
  };
};

export var createStructuredSelector = function createStructuredSelector(selectorObject) {
  return function () {
    for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    var result = {};
    Object.keys(selectorObject).forEach(function (key) {
      result[key] = selectorObject[key].apply(selectorObject, args);
    });
    return result;
  };
};