"use strict";

exports.__esModule = true;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _backbone = require("backbone");

var _backbone2 = _interopRequireDefault(_backbone);

var _const = require("../const");

var _getDisplayName = require("../utils/getDisplayName");

var _getDisplayName2 = _interopRequireDefault(_getDisplayName);

var _shallowEqual = require("../utils/shallowEqual");

var _shallowEqual2 = _interopRequireDefault(_shallowEqual);

var _StoreWatcher = require("../StoreWatcher");

var _StoreWatcher2 = _interopRequireDefault(_StoreWatcher);

var _createMapToProps = require("./createMapToProps");

var _createMapToProps2 = _interopRequireDefault(_createMapToProps);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.default = function (mapModelToProps, mapTriggerToProps, mergeProps) {
  return function (WrappedComponent) {
    var _Connectted$contextTy;

    var Connectted = function (_Component) {
      _inherits(Connectted, _Component);

      function Connectted(props, context) {
        _classCallCheck(this, Connectted);

        var _this = _possibleConstructorReturn(this, _Component.call(this, props, context));

        _this.storeWatcher = new _StoreWatcher2.default(context[_const.CONTEXT_KEY]);
        _this.mapToProps = (0, _createMapToProps2.default)(_this.storeWatcher.wrappedStore, props, mapModelToProps, mapTriggerToProps, mergeProps);

        _this.state = {
          mergedProps: _this.mapToProps.getMergedProps()
        };

        _this.storeWatcher.on("change", function () {
          _this.mapToProps.storeUpdated();
          _this.setState({
            mergedProps: _this.mapToProps.getMergedProps()
          });
        });
        return _this;
      }

      Connectted.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
        if ((0, _shallowEqual2.default)(this.props, nextProps)) {
          return;
        }
        this.mapToProps.updateProps(nextProps);
        this.mapToProps.getMergedProps();
        this.setState({
          mergedProps: this.mapToProps.getMergedProps()
        });
      };

      Connectted.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
        return this.state.mergedProps !== nextState.mergedProps;
      };

      Connectted.prototype.componentWillUnmount = function componentWillUnmount() {
        this.storeWatcher.destory();
      };

      Connectted.prototype.render = function render() {
        return _react2.default.createElement(WrappedComponent, this.state.mergedProps);
      };

      return Connectted;
    }(_react.Component);

    Connectted.displayName = "BackboneConnect(" + (0, _getDisplayName2.default)(WrappedComponent) + ")";
    Connectted.contextTypes = (_Connectted$contextTy = {}, _Connectted$contextTy[_const.CONTEXT_KEY] = _propTypes2.default.object, _Connectted$contextTy);
    Connectted.WrappedComponent = WrappedComponent;

    return Connectted;
  };
};